# -*- coding:Utf-8 -*-

import es
import gamethread
import msglib
import langlib
import playerlib
import os
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "redirectlib"
info.version = "1.1"
info.author = "EmbouT"
info.url = "http://mattie.info/forums/"
info.description = "Provided a class to redirect a player on another server"


# This script was inspired by that of SuperDave : http://forums.mattie.info/cs/forums/viewtopic.php?t=18588

### GLOBAL VARIABLE ###

# duration display redirection set by the server administrator (may be float)
default_delay = 15

default_kick = 1

lang = None

### CLASS ###

class Redirect(object):
    def __init__(self,ip,password='',kick=1,delay=float(default_delay)):
        if str(delay)=='':delay=float(default_delay)
        try:
            self.time=float(delay)
            if not int(self.time):self.time=float(default_delay)
        except ValueError:
            es.dbgmsg(0,'[redirectlib] delay (%s) must be a number'%delay)
            es.dbgmsg(0,'[redirectlib] delay is set to default value : %s'%default_delay)
            self.time = float(default_delay)

        if str(kick)=='':kick=default_kick
        try:
            self.kick=int(kick)
        except ValueError:
            es.dbgmsg(0,'[redirectlib] kick (%s) must be 1 or 0'%kick)
            es.dbgmsg(0,'[redirectlib] kick is set to default value : %i'%default_kick)
            self.kick=default_kick

        if not str(password)=='':
            self.server=ip+';password '+str(password)
        else :
            self.server = ip


    def send(self,userid):
        if userid:
            if not es.exists('userid', userid):
                es.dbgmsg(0,'[redirectlib] %s is an invalid userid'%userid)
            else :
                msglib.VguiDialog(title=self.server, time=self.time, mode=msglib.VguiMode.ASKCONNECT).send(userid)
                if self.kick:
                    gamethread.delayedname(self.time,'redirectlibkick%s'%userid,kickplayer,(self.server,userid))

def kickplayer(ip,userid):
    global lang
    es.server.queuecmd('kickid %s "%s"'%(userid,lang('kick',{'ip':ip},playerlib.getPlayer(userid).get('lang'))))

def player_disconnect(event_var):
    gamethread.cancelDelayed('redirectlibkick%s'%event_var['userid'])

def loadlang():
    global lang
    path = es.getAddonPath('redirect') + '/redirect_languages.ini'
    if os.path.isfile(path):
        lang = langlib.Strings(path)
    else:
        es.dbgmsg(0,'[redirectlib] Unable to load redirect_languages.ini! Please ensure it is in the ../redirect/ directory.')
    if not lang:
        lang = nolang

def nolang(t,o,l):
    # if redirect_languages.ini is not found, set default message
    return 'Please Try %s in your console'%o['ip']

es.addons.registerForEvent(__import__(__name__), 'player_disconnect', player_disconnect)
loadlang()

